Bug 25681 - F# compiler generates code with stack overflow for trivial recursion (GCD)
Summary: F# compiler generates code with stack overflow for trivial recursion (GCD)
Status: RESOLVED FIXED
Alias: None
Product: Runtime
Classification: Mono
Component: JIT (show other bugs)
Version: unspecified
Hardware: PC Linux
: --- normal
Target Milestone: ---
Assignee: Bugzilla
URL:
Depends on:
Blocks:
 
Reported: 2015-01-02 03:08 UTC by William Webber
Modified: 2018-02-28 22:51 UTC (History)
4 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description William Webber 2015-01-02 03:08:41 UTC
Following simple code:

let rec gcd x y =
    if y = 0 then
        x
    else
        gcd y (x % y)

let test1 = gcd 1024 12
printfn "%d" test1

Runs correctly in fsharpi.
Compile with fsharpc; resulting executable produces error of form:

Stack overflow: IP: 0x40c25d74, fault addr: (nil)
Stacktrace:

Insert printfn statement anywhere within the gcd function, and the code works.
Comment 1 Ludovic Henry 2018-02-28 22:51:24 UTC
I cannot reproduce with Mono 5.13.0.220 (master/798c5efa52a).